export default class Char {
    x;
    y;
    angle=0;
    width=30;
    height = 30;
    v = 0;

    constructor(x, y, couleur) {
        this.x = x;
        this.y = y;
        this.couleur = couleur;
    }

    draw(ctx) {
        // BONNE PRATIQUE : dès qu'on touche à une propriété du contexte
        // couleur, ombres, taille des polices, geométrie etc.
        // On le sauvegarde au début de la méthode, et on le restaure à la fin
        ctx.save();

        // On déplace le repère à la position x, y
        ctx.translate(this.x, this.y);

        // Pour que le rectangle tourne autour de son centre et pas du coin en haut à gauche
        ctx.rotate(this.angle);
        ctx.translate(-this.width/2, -this.height/2);

        // dessiner le corps du char
        ctx.fillStyle = this.couleur;
        ctx.fillRect(0, 0, this.width, this.height);

        // dessiner le canon (une droite)
        ctx.beginPath();
        ctx.moveTo(this.width/2, this.height/2);
        ctx.lineTo(this.width/2 + 40, this.height/2);
        ctx.stroke();

        ctx.restore();
    }

    viseCible(pos) {
        // on calcule l'angle du char en fonction des deux points : sa position et la position
        // de la souris
        if(pos.x === undefined) return;

        const dx = this.x - pos.x;
        const dy = this.y - pos.y;
        this.angle = Math.atan2(-dy, -dx);
    }

    move() {
        const incX = this.v * Math.cos(this.angle);
        const incY = this.v * Math.sin(this.angle);
        this.x += incX;
        this.y += incY;
    }
}