import Char from './Char.js'

// executer un truc (le programme principal) uniquement quand la page est chargée
// et quand les ressources dans la page sont prêtes (sons, videos, etc.)
window.onload = init;

// variables globales
let canvas, height, width, ctx;
let x1 = 10;
let x2 = 40;
let vx = 10;
let char1;
let inputStates = {
    up:false,
    down:false,
    left: false,
    right: false
};
let mousePos = {}

function init() {
    console.log("PAGE CHARGEE, prêt à démarrer le jeu...");

    // on récupère avec un selecteur CSS le canvas sous forme d'objet
    // utilisation de la querySelector API de HTML5
    canvas = document.querySelector("#myCanvas");
    width = canvas.width;
    height = canvas.height;

    // Une fois qu'on a le canvas on doit récupérer le contexte pour dessiner
    ctx = canvas.getContext('2d');

    creerLesEcouteurs();

    // Je crée un char
    char1 = new Char(100, 100, 40, 40);

    requestAnimationFrame(mainloop); // On démarre la boucle principale d'animation
    // du jeu
}

function creerLesEcouteurs() {
    window.onkeydown = traiteKeyDown;
    window.onkeyup = traiteKeyUp;

    canvas.onmousemove = traiteDeplacementsSouris;
}

function traiteDeplacementsSouris(event) {
    let x = event.clientX;
    let y = event.clientY;

    let rect = canvas.getBoundingClientRect();

    mousePos.x = x - rect.left;
    mousePos.y = y - rect.top;
}

function traiteKeyDown(event) {
    console.log(event);
    switch (event.key) {
        case 'z':
            inputStates.up = true;
            break;
        case 's':
            inputStates.down = true;
            break;
        case 'q':
            inputStates.left = true;
            break;
        case 'd':
            inputStates.right = true;
            break;
    }
}
function traiteKeyUp(event) {
    //console.log(event);
    switch (event.key) {
        case 'z':
            inputStates.up = false;
            break;
        case 's':
            inputStates.down = false;
            break;
        case 'q':
            inputStates.left = false;
            break;
        case 'd':
            inputStates.right = false;
            break;
    }
}

function mainloop() {
    // 1 - effacer le contenu du canvas
    ctx.clearRect(0, 0, width, height);

    // 2 - dessiner les objets
    char1.draw(ctx);

    // 3 - deplacer les objets
    if (inputStates.right) {
        //par exemple déplacer le char à droite
    } 
    if (inputStates.left) {
        //deplacer le char à gauche
    } 

    if (inputStates.up) char1.v = 3; 
    if (inputStates.down) char1.v = -3; 
    if(!inputStates.up && !inputStates.down) char1.v = 0;

    // faire tourner le char vers le curseur de la souris
    if (mousePos) {
        // tourner la tourelle (pour le moment c'est le char qui tourne)
        char1.viseCible(mousePos);
        char1.move();
    }

    // 3 - se rappeler (en fait non, demander au browser de la rappeler dans 1/60ème de seconde)
    requestAnimationFrame(mainloop);
}


function dessinerLesRectangles() {
    // on dessine fillRect = dessin immédiat d'un rectangle (x, y, l, h)
    // fillStyle = pour le dessin plein, prend une couleur CSS
    // ou un gradiant (dégradé) ou une texture, voir cours
    ctx.strokeStyle = "rgba(100, 23, 23, 0.5)";

    ctx.lineWidth = 10;
    ctx.strokeRect(x1, 10, 100, 100);
    ctx.strokeRect(x2, 40, 100, 100);
}

